//+------------------------------------------------------------------+
//|                                    ay-TPOChart-Session.v1.20.mq4 |
//|                      Copyright ?2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2011, ahmad.yani@hotmail.com"
#property link      "http://eyesfx.web44.net"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 14
/******************************************************************\\\
 * MP Library 
 * dont change anything in this mp library block, unless YKWYD.....
 ******************************************************************///say something here...
#include <ay-mplib.const.v102.mqh>                                  //
                                                                    //
#import "ay-mplib.v102.ex4"                                         //
void MpGet                                                          //
   (                                                                //   
        double    dparam[4]                                         //
      , int       iparam[4]                                         //
      , double    arates[][6]                                       //
      , double&   mpdataperrow[][MPSIZE]                            //result: price per row (price, tpo, vol)  
      , int&      mplinesidx[MPLNSIZE]                              //result: lines index
      , double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
      , int&      mpletter[][MPLTSIZE]                              //result: letter  
   );                                                               //
#import                                                             //
/******************************************************************\\\
 * End MP Library 
 ******************************************************************///
 
/******************************************************************\\\
 * Indicator Constant
 ******************************************************************/// 
#define IND_NAME        "TPOChart Session v1.20"
#define SES_START       0                                            //
#define SES_END         1                                            //
#define A_SES           0                                            //  Asia Session
#define E_SES           1                                            //Europe Session
#define U_SES           2                                            //    US Session
#define MPLFONTNAME     "lucida sans typewriter bold"
#define MPLFONTNAME2    "lucida sans typewriter"
#define MPLFONTSIZE     8
#define MG_ASIA_EUROPE  "A"
#define MG_EUROPE_US    "B"
#define MG_ALL          "C"

/******************************************************************\\\
 * End Indicator Constant
 ******************************************************************/// 

//--- input parameters
extern bool       EnableMergeProfile       = false;
extern string     MergeProfileInfo         = "A Asia+Europe, B Europe+US, C All";
extern string     MergeProfile             = "A";
extern bool       ExtendIB                 = false;
extern bool       ShowSplitProfile         = true;
extern bool       PaintLettersOnVolume     = true;
extern bool       ShowHorizontalVolume     = false;
extern bool       ShowVolumeRatio          = true;
extern double     MinVolumeRatio           = 1.5;
extern string     AsiaOpen                 = "23:00";
extern string     EuropeOpen               = "09:00";
extern string     USOpen                   = "14:00";
extern int        NumDays                  = 10;
extern int        SplitProfileNumDays      = 0;
extern int        RowHeight                = 1;
extern int        ProfileDataTf            = 30;
extern double     VAPercent                = 70.0;
extern int        IBNumBars                = 2;
extern int        UpdateInterval           = 0;
extern string     spr1                     = "Colors.............";
extern color      AsColor                  = Khaki;
extern color      EuColor                  = Magenta;
extern color      UsColor                  = Aqua;
extern color      VAColor                  = C'25,25,45';
extern color      POCColor                 = Yellow;
extern color      HistogramColor           = C'0,64,128';
extern color      BarBullColor             = MediumBlue;//C'0,200,0';
extern color      BarBearColor             = Maroon;//C'200,0,0';
extern color      BarNetralColor           = DimGray;
extern color      OpenCloseColor           = Gray;
extern color      WindowInfoColor          = Silver;
extern color      UpVolumeColor            = PaleGreen;
extern color      DownVolumeColor          = Chocolate;
extern color      NeutralVolumeColor       = DodgerBlue;

//-->global vars
int        giStep
         , giDigits
         , giWinId
         ;
double     gdaRates[][6]
         , gdOneTick
         , gdPoint
         ;     
color      gcHistoColor;         
bool       gbFirstRun = true;
string     gsaLetter[] = 
            {
             "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"
            ,"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"
            } 
         , gsPref = "ay.mpls."
         ; 
color      gcSesColor[3];
datetime   gdtaMST[][3][2];   //--array market session time;            
//<--global vars   
 
#include <ay-object.func.v1.1.mqh>
#include <ay-TPOChart-Session.v1.20.helper.mqh>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   IndicatorShortName(IND_NAME);
      
   if (Point == 0.001 || Point == 0.00001) 
   { gdPoint = Point*10; giDigits = Digits - 1; }
   else 
   { gdPoint = Point; giDigits = Digits; } 
   
   gdOneTick = 1/MathPow(10, giDigits);
   
   giStep = MathMax(RowHeight, 1);
   
   ArrayCopyRates(gdaRates, NULL, ProfileDataTf);        
   
   gcSesColor[A_SES] = AsColor;
   gcSesColor[E_SES] = EuColor;
   gcSesColor[U_SES] = UsColor;
   
   //--
   ArrayResize(gdtaMST, NumDays);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{         
   delObjs();
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   
   static bool       isbusy;
   static datetime   lastdaystart;
   static datetime   lastsesstart;   
   
   if (isbusy || !isHistoryOK() || !secondDiff() ) { return(0); }   
   
   isbusy = true;   
   
   datetime   currtime     = iTime(NULL, ProfileDataTf, 0);
   datetime   currsesstart;
   datetime   currdaystart = StrToTime( TimeToStr(currtime, TIME_DATE) + " " + AsiaOpen );
   datetime   dtAO               //--dt asia open
            , dtAE               //--dt asia end
            , dtEO               //--dt europe open
            , dtEE               //--dt europe end
            , dtUO               //--dt us open
            , dtUE               //--dt us end
            ;   
   string     stribdtime;
   int        iday, ises, maxdays = NumDays           
            , ibd, ibarday = iBarShift(NULL, PERIOD_D1, currtime)    //--so you can reply in ea
            ; 
   bool       bdelallobjs; //--
   
   
   giWinId = WindowFind(IND_NAME);
   
   if (currdaystart > currtime) currdaystart -= PERIOD_D1*60;
   
   if (currdaystart != lastdaystart)
   {
      //maxdays = NumDays;      
      for (iday=0, ibd=ibarday; iday<maxdays; iday++, ibd++)
      {
         stribdtime = TimeToStr(iTime(NULL, PERIOD_D1, ibd), TIME_DATE);
         
         dtAO  = StrToTime( stribdtime + " " + AsiaOpen );
         //--asia open is in future time
         if ( TimeHour(currtime) < TimeHour(dtAO) ) dtAO -= PERIOD_D1*60;
            
         dtEO  = StrToTime( stribdtime + " " + EuropeOpen );
         if (dtEO<dtAO) dtEO += PERIOD_D1*60;
         
         dtUO  = StrToTime( stribdtime + " " + USOpen );  
         if (dtUO<dtEO) dtUO += PERIOD_D1*60; 
                           
         dtAE  = dtEO - 1;                   //--profile end @EO            
         dtEE  = dtUO - 1;                   //--profile end @UO
         dtUE  = dtAO + (PERIOD_D1*60) - 1;  //--profile end @next AO
      
         if (EnableMergeProfile && MergeProfile == MG_ASIA_EUROPE) dtAE = dtUO -1;
         if (EnableMergeProfile && MergeProfile == MG_EUROPE_US)   dtEE = dtUE;
         if (EnableMergeProfile && MergeProfile == MG_ALL)         dtAE = dtUE;
      
      
         gdtaMST[iday][A_SES][SES_START]   = dtAO;
         gdtaMST[iday][A_SES][SES_END]     = dtAE;      
      
         gdtaMST[iday][E_SES][SES_START]   = dtEO;
         gdtaMST[iday][E_SES][SES_END]     = dtEE;
               
         gdtaMST[iday][U_SES][SES_START]   = dtUO;
         gdtaMST[iday][U_SES][SES_END]     = dtUE;   
          
      }

      lastdaystart = currdaystart;
      bdelallobjs  = true;
   }
   
   //--find current session start time
   for (ises = A_SES; ises <= U_SES; ises++)      
   {   
      if ( gdtaMST[0][ises][SES_END] > currtime ) 
      {
         currsesstart =  gdtaMST[0][ises][SES_START];
         if (lastsesstart != currsesstart)
         {
            bdelallobjs  = true;
            lastsesstart = currsesstart;
         }
         break;
      }
   }
   
   if (bdelallobjs)
   {
      delObjs();
      maxdays = NumDays;
   }
   else maxdays = 1;      
   
   //-->|
   createProfile (maxdays, currtime, currsesstart);   
   //<--|
   
   isbusy = false;   
   
   return(0);   
}

void createProfile
(
     int       maxdays
   , datetime  currtime
   , datetime  currsesstart   
)
{
   static int      lastmaxtpo;
   
   //-->MpGet Vars
   double     hh, ll
            , rhh  //round hh to rowheight
            , rll  //round ll to rowheight;
            ;
            //, ibh, ibl;
   int        sb, eb;    
   double     mpdata  [][MPSIZE];
   int        mplines   [MPLNSIZE];
   double     mptotal   [MPTSIZE];
   int        mpletter[][MPLTSIZE];   
   double     dparam[4];
   int        iparam[4];      
   int        ratessize = iBars(NULL, ProfileDataTf)
            , mpdatasize;
   //<--MpGet Vars         
   
   
   double     poc, midrowpoc, vpoc,vah, val, open, close   
            , rg = (giStep/1.0)/(MathPow(10,giDigits))
            , ibh, ibl        
            ;    
   int        iday, ises
            , maxtpo
            , startprofile
            , laststartprofile = 0
            , space = 4                                              //--space between profile
            , objtotal, iobj, objtype
            , idayobj, isesobj
            , textwidth            
            ;                        
   bool       bcurrsession
            , newbar = isNewBarDataTf()
            , isobjmp
            , bmaxdays1andcurrses
            , bmaxtpochange
            , bmaxtpochangeornewbar
            , bmaxtpochangeandnewbar
            , bobjincurrses
            ;             
   string     objname, strinfo[12];     
  
                     
   if (ShowHorizontalVolume) space += 5;
   if (ShowVolumeRatio)      space += 4;   
   
   //-->DAY LOOP
   for (iday=0; iday<maxdays; iday++)
   {      
      //-->session loop
      for (ises=2; ises>=0; ises--)      
      {               
         //--session not yet started
         if (gdtaMST[iday][ises][SES_START] > currtime ) continue;
         
         //--skip when session is merged to prev sesssion
         if (  EnableMergeProfile 
               && 
               (            
                  (MergeProfile == MG_ASIA_EUROPE && ises==1)
                  || 
                  (MergeProfile == MG_EUROPE_US && ises==2)
                  || 
                  (MergeProfile == MG_ALL && (ises==1 || ises==2))
               )
            )  continue;
                     
         //--are we in current session?
         if ( gdtaMST[iday][ises][SES_START] == currsesstart ) 
              bcurrsession = true;
         else bcurrsession = false;                           

         //--only update current session
         if (maxdays == 1 && !bcurrsession) break;         
         
         //--get session start bar and end bar                        
         getSesSE
         (
              ProfileDataTf
            , gdtaMST[iday][ises][SES_START]
            , gdtaMST[iday][ises][SES_END]
            , sb
            , eb
          );
                           
         if (    sb<0 
              || eb<0                              
              || ( sb==eb && iday != 0 ) //stupid sunday bar... arrgghh when asia start set to sydney open
            ) 
         {
            //Print("skipping day#", iday, " ses#", ises, " sb ", sb, " eb ", eb);
            continue;
         }
         

                  
         //-->Prepare data for library fn call    
         getHHLL(ProfileDataTf, sb, eb, hh, ll);      
         rhh = MathCeil(hh/rg) * rg;
         rll = MathCeil(ll/rg) * rg;
         if (rhh < hh) rhh += rg;
         if (rll > ll) rll -= rg;      
      
         dparam[MPDP_ONETICK]    = gdOneTick;
         dparam[MPDP_HH]         = rhh;
         dparam[MPDP_LL]         = rll;
         dparam[MPDP_VAPERCENT]  = VAPercent;

         iparam[MPIP_STARTBAR]   = sb;
         iparam[MPIP_ENDBAR]     = eb; 
         iparam[MPIP_DIGITS]     = giDigits;
         iparam[MPIP_STEP]       = giStep;  
         //<--Prepare data for library fn call  
         
         //-->call library
         MpGet
            (  
                 dparam       //double    dparam[4]
               , iparam       //int       iparam[4]
               , gdaRates     //double    arates[][6]
               , mpdata       //double&   mpdata[][MPSIZE]                                  //result: data
               , mplines      //int&      mplinesidx[MPLNSIZE]                              //result: lines index
               , mptotal      //double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
               , mpletter     //int&      mpletter[][MPLTSIZE]                              //result: letter  
            );
         //<--call library         
      
         mpdatasize = ArraySize(mpdata)/MPSIZE;
         maxtpo     = mpdata[ mplines[MPL_TPOPOC] ][MP_TPO];            
         
         //--calculate startprofile  
         startprofile = laststartprofile + maxtpo + space;
         if ( ShowSplitProfile && (iday<SplitProfileNumDays || bcurrsession) ) startprofile += (2*(sb - eb)) + 4;   
         
         if ( startprofile > (Bars-1)) continue;
         
         //-->some conditions shortcut                  
         bmaxdays1andcurrses    = (maxdays==1 && bcurrsession);   //--we are in current session and only day 0 will be updated       
         bmaxtpochange          = (lastmaxtpo != maxtpo);         //--maxtpo change         
         bmaxtpochangeornewbar  = (newbar || bmaxtpochange);      //--maxtpo change or new bar occurred         
         bmaxtpochangeandnewbar = (newbar && bmaxtpochange);      //--maxtpo change and new bar occurred                  
         //<--some conditions shortcut 
         
         if (bmaxdays1andcurrses) 
         {
            objtotal  = ObjectsTotal();
            //-->find all mp objects
            for (iobj = objtotal-1; iobj>=0; iobj--)
            {
               objname = ObjectName(iobj);   
               objtype = ObjectType(objname);                            
               isobjmp = (StringFind(objname, gsPref) != -1);
               
               if (!isobjmp) continue;
               
               //--get iday and ises obj 
               getDaySesObj(objname, idayobj, isesobj); 
               //obj is in current session and current day
               bobjincurrses = (idayobj == 0 && isesobj == ises);
               
               //--delete current session obj            
               if (bobjincurrses) ObjectDelete(objname);  
               
               //-->move all prev profile by one/two period 
               //---if newbar occurred or current session maxtpo changed 
               if (!bobjincurrses && bmaxtpochangeornewbar)
               {
                  int adj = 1;                  
                  //--maxtpo changed when newbar event occur                     
                  if (bmaxtpochangeandnewbar) adj++;
                  
                  moveObj(objname, objtype, adj);                                                                         
               }
               //<--move all prev profile       
            }
            //<--find all mp objects
            
            if (bmaxtpochange) lastmaxtpo = maxtpo;                                    
         }
                 
         //--update lastmaxtpo
         if ( (maxdays>1 && bcurrsession) ) lastmaxtpo = maxtpo;   
         //--update laststartprofile            
         laststartprofile = startprofile;
         
         //--> let setup the scrabble set
         drawPriceLetter
         (
              iday               //int    iday
            , ises               //int    ises
            , startprofile       //int    sbprofile
            , sb                 //int    sbdatatf
            , sb - eb            //int    totalbar
            , mpdatasize         //int    mpdatasize           
            , mpdata             //double mpdata[][]
            , mplines            //int    mplines[]
            , mpletter           //int    mpletter[][]
            , gcSesColor[ises]   //color  lettercolor
            , space              //int    spaceinfo
            , bcurrsession
         );   
         //<--
                       
         open      = iOpen(NULL, ProfileDataTf, sb);
         close     = iClose(NULL, ProfileDataTf, eb);               
         poc       = mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE];
         midrowpoc = mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE] - 0.5*(giStep*gdOneTick);
         vpoc      = mpdata[ mplines[MPL_VOLPOC] ][MP_PRICE];
         vah       = mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE];
         val       = mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE] - (giStep*gdOneTick);         
                
         //--Session IB                                      
         getHHLL(ProfileDataTf, sb, MathMax(sb-(IBNumBars-1), 0), ibh, ibl);
                                                             
         //profile ohlc bar
         drawBar( iday, ises, startprofile+2, open, hh, ll, close );
         //--value area
         createRect( "#" + iday + "#" + ises + ".va" 
            , vah, Time[ startprofile + 1 ]
            , val, Time[ startprofile - (maxtpo+1) ]
            , VAColor );          
         //--poc
         createText( "#" + iday + ".1.1.#" + ises + ".poc"
            , Time[startprofile - (maxtpo+1)]
            , poc
            , "n"
            , MPLFONTSIZE, "wingdings", POCColor
            );    
          //--vpoc 
          createText( "#" + iday + ".1.1.#" + ises + ".vpoc"
            , Time[startprofile - (maxtpo+1)]
            , vpoc
            , "u"
            , MPLFONTSIZE, "wingdings", POCColor
            ); 
         //--ib
         createTl("#" + iday + ".1.1.#" + ises + ".ib"
            , Time[ startprofile + 1 ], ibh
            , Time[ startprofile + 1 ], ibl
            , POCColor, STYLE_SOLID, 3, false
            );   
            
         //--extended ib      
         if (ExtendIB)
         {     
            for (int ib=1; ib<5; ib++)
            {            
              createTl("#" + iday + ".1.1.#" + ises + ".ibh" + (ib+1) + "x"
                  , Time[ startprofile + 1 ], ibh+ib*(ibh-ibl)
                  , Time[ startprofile + 1 ], ibh+ib*(ibh-ibl)-0.5*gdOneTick
                  , POCColor, STYLE_SOLID, 2, false
                  ); 
            
               createTl("#" + iday + ".1.1.#" + ises + ".ibl" + (ib+1) + "x"
                  , Time[ startprofile + 1 ], ibl-ib*(ibh-ibl)
                  , Time[ startprofile + 1 ], ibl-ib*(ibh-ibl)-0.5*gdOneTick
                  , POCColor, STYLE_SOLID, 2, false
                  ); 
            }
         } 
         
         //--updateWindowInfo                     
         textwidth   = 16; 
         strinfo[0]  = addStr(TimeToStr(iTime(NULL, ProfileDataTf, sb))         , " ", textwidth, false); 
         strinfo[1]  = addStr("O     : " + DoubleToStr(open, giDigits)          , " ", textwidth, false); 
         strinfo[2]  = addStr("H     : " + DoubleToStr(hh, giDigits)            , " ", textwidth, false); 
         strinfo[3]  = addStr("L     : " + DoubleToStr(ll, giDigits)            , " ", textwidth, false); 
         strinfo[4]  = addStr("C     : " + DoubleToStr(close, giDigits)         , " ", textwidth, false);          
         strinfo[5]  = addStr("V     : " + DoubleToStr(mptotal[MPT_VOL], 0)     , " ", textwidth, false);  
         strinfo[6]  = addStr("RANGE : " + DoubleToStr((hh-ll)/gdPoint, 0)      , " ", textwidth, false); 
         strinfo[7]  = addStr("VAH   : " + DoubleToStr(vah, giDigits)           , " ", textwidth, false); 
         strinfo[8]  = addStr("POC   : " + DoubleToStr(midrowpoc, giDigits)     , " ", textwidth, false); 
         strinfo[9]  = addStr("VAL   : " + DoubleToStr(val, giDigits)           , " ", textwidth, false);  
         strinfo[10] = addStr("IBH   : " + DoubleToStr(ibh, giDigits)           , " ", textwidth, false); 
         strinfo[11] = addStr("IBL   : " + DoubleToStr(ibl, giDigits)           , " ", textwidth, false); 
         
         updateWindowInfo
         (
              Time[startprofile]
            , iday
            , ises
            , strinfo
         );                                     

      }
      //<--session loop
   }
   //<--DAY LOOP   
}


/**
 *
 */
void drawPriceLetter
(
     int    iday
   , int    ises
   , int    sbprofile
   , int    sbdatatf
   , int    totalbar
   , int    mpdatasize           
   , double mpdata[][]
   , int    mplines[]
   , int    mpletter[][]
   , color  sesslettercolor
   , int    spaceinfo
   , bool   bcurrsession
)
{          
   
   int        maxtpoidx  = mplines[MPL_TPOPOC];
   double     maxtpo     = mpdata[maxtpoidx][MP_TPO];
   int        imaxtpo    = mpdata[maxtpoidx][MP_TPO];
   double     volratio;
   color      lettercolor;        
   int        step, j, pos, letterid, infopos;
   string     letter, strvolratio, emptystrvol = "   "; //3 spaces   
   double     openp, closep;//   =  gdaRates[sbdatatf-letterid][_CLOSE];
   
   for (step = 0; step < mpdatasize; step++) //+= giStep)
   {
      
      if (/*ShowHorizontalVolume && */mpdata[ step ][MP_VOL] > 0)
      {

         volratio    = 0;
         strvolratio = emptystrvol; //3 spaces
         if (mpdatasize > 3/*min step  required*/  && mpdata[ step ][MP_VOL] > 0)
         {
            if (step < mplines[MPL_VOLPOC] && (step+1) < mpdatasize)            
               volratio = mpdata[ step+1 ][MP_VOL] / mpdata[ step ][MP_VOL];                           
            
            if (step > mplines[MPL_VOLPOC] && (step-1) >= 0)            
               volratio = mpdata[ step-1 ][MP_VOL] / mpdata[ step ][MP_VOL];               
                     
            if (volratio >= MinVolumeRatio)
               strvolratio =  DoubleToStr(volratio,1);    
         }
         
         string strvol;
         if (ShowHorizontalVolume && ShowVolumeRatio)
         {
            strvol =  addStr(DoubleToStr(mpdata[ step ][MP_VOL],0) + " ?" + strvolratio, " ", 16);   
            infopos = 9;                     
         }
         
         if (ShowHorizontalVolume && !ShowVolumeRatio)
         {
            strvol =  addStr(DoubleToStr(mpdata[ step ][MP_VOL],0), " ", 6);   
            infopos = 5;                       
         }
         
         if (!ShowHorizontalVolume && ShowVolumeRatio)
         {
            strvol =  addStr(strvolratio, " ", 6);    
            infopos = 5;                      
         }
         
         if (StringLen(StringTrimLeft(strvol)) != 0)
            createText( "#" + iday + ".1.2.#" + ises + ".vol." + step
               , Time[sbprofile+infopos]
               , mpdata[ step ][MP_PRICE]
               , strvol 
               , MPLFONTSIZE-2, MPLFONTNAME2, sesslettercolor
               );  
      }

      pos = sbprofile;
      for (j=0; j<512; j++)
      {        
         if ( mpletter[step][j] == -1) break;
                           
         letterid =  mpletter[step][j] ;
         if (letterid>50) letterid = MathMod(letterid,50);
         
         letter = gsaLetter[ letterid ];
         
         if (PaintLettersOnVolume)            
         {
            double v0 = iVolume(NULL,ProfileDataTf,(sbdatatf - letterid) + 0);
            double v1 = iVolume(NULL,ProfileDataTf,(sbdatatf - letterid) + 1);
            double v2 = iVolume(NULL,ProfileDataTf,(sbdatatf - letterid) + 2);
            
            if ( v0<v1 && v0<v2 )
            {
               lettercolor = DownVolumeColor;
            }
            else   
            if ( v0>v1 && v0>v2 )
            {
               lettercolor = UpVolumeColor;
            }
            else lettercolor = NeutralVolumeColor;
         }
         else lettercolor = sesslettercolor;
         
         createText( "#" + iday + ".1.2.#" + ises + ".letter." + step + "-" + j
            , Time[pos]
            , mpdata[ step ][MP_PRICE]
            , letter
            , MPLFONTSIZE, MPLFONTNAME, lettercolor
            );          
         
         
         //--separated letters aka split profile
                 
         if (ShowSplitProfile && ( iday<SplitProfileNumDays||bcurrsession) )
         {

            int x = maxtpo + (mpletter[step][j]*2) + 4;
                                   
            createText( "#" + iday + ".1.2.#" + ises + ".barletter." + step + "-" + mpletter[step][j] 
               , Time[sbprofile - x] 
               , mpdata[ step ][MP_PRICE]
               , letter
               , MPLFONTSIZE, MPLFONTNAME, lettercolor
               );
               
            openp  = gdaRates[ sbdatatf - mpletter[step][j] ][_OPEN];   
            closep = gdaRates[ sbdatatf - mpletter[step][j] ][_CLOSE];   
            
            if (    openp <= mpdata[ step ][MP_PRICE] 
                 && openp >  mpdata[ step ][MP_PRICE] - (giStep*gdOneTick)
               )
            {
               createText( "#" + iday + ".1.1.#" + ises + ".barletter.openp." + mpletter[step][j] 
                  , Time[sbprofile - x ] 
                  , mpdata[ step ][MP_PRICE]
                  , "s "//ss"?" //" `" //"  ?
                  , MPLFONTSIZE-2, "Wingdings",  lettercolor//OpenCloseColor
                  );               
            
            }                     
               
            if (    closep <= mpdata[ step ][MP_PRICE] 
                 && closep >  mpdata[ step ][MP_PRICE] - (giStep*gdOneTick)
               )
            {
               createText( "#" + iday + ".1.1.#" + ises + ".barletter.closep." + mpletter[step][j] 
                  , Time[sbprofile - x ] 
                  , mpdata[ step ][MP_PRICE]
                  , "////"
                  , MPLFONTSIZE-2, "Wingdings",  OpenCloseColor
                  );               
            
            }
         }
         
         pos--;
      }      
   }
   
      
}


//+------------------------------------------------------------------+